VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "IISWebAdmin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "IIS     ϴ Ʈ."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"

'****************************************************************************************
'*
'*  EgoCube.IISWebAdmin Component   Component Դϴ. ,  
'*  𼭳 Ӱ Ͻ  ֽϴ.
'*
'*  ٸ,  ߰    Code  ϼ ,   
'*   Ͽ   ּż   ݿ  ֵ ֽø 
'*  ڽϴ. , ̷  Code     Ͽ  Ȩ
'*  뿡 ߰ϵ ϰڽϴ. ó  ϴ.
'*
'*  Homepage URL : http://user.chollian.net/~hipster74
'*  E-Mail       : hipster74@chollian.net
'*     : 2002.06.26
'*
'****************************************************************************************


Option Explicit


'** Event Log Message   ü ̸ 
Private Const sObjectName   As String = "EgoCube.IISWebAdmin"


'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function GetWebServerState(WebServerIndex As Integer,
'*                                                Optional WebServerName As String = "") As Integer
'*       ::      ¸ Ѵ.
'*                1 -  
'*                2 - ۵
'*                3 -  
'*                4 - 
'*                5 - Ͻ  
'*                6 - Ͻ 
'*                7 - 
'*               -1 - 
'*       :: ۿ
'*      ¥ :: 2002.01.22
'*
'****************************************************************************************

Public Function GetWebServerState(WebServerIndex As Integer, _
                                  Optional WebServerName As String = "") As Integer
Attribute GetWebServerState.VB_Description = "     ¸ Ѵ."

    Dim WebServer               As Object           '** IISWebServer ü
    Dim ADsPath                 As String           '** IISWebServer ü ADsPath
    
    
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
    
On Error GoTo Error_Handler:

    
    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    WebServerName = Trim(WebServerName)
    
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC/" & CStr(WebServerIndex)
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC/" & CStr(WebServerIndex)
    End If
    
    
    '****************************************************************
    '*      ¸ ´.
    '****************************************************************
    
    Set WebServer = GetObject(ADsPath)
    GetWebServerState = WebServer.ServerState
    Set WebServer = Nothing
    
    
    Exit Function
    
    
Error_Handler:


    '** Error ߻ -1  Return Ѵ.
    GetWebServerState = -1
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".GetWebServerState()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** IISWebServer ü 
    If Not WebServer Is Nothing Then
        Set WebServer = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function
    
    
End Function


'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function SetWebServerState(WebServerIndex As Integer,
'*                                                StateNumber As Integer,
'*                                                Optional WebServerName As String = "") As Integer
'*       ::      ¸  ,
'*                1 - 
'*                2 - 
'*                3 - Ͻ 
'*                    ¸ Ѵ.
'*                1 -  
'*                2 - ۵
'*                3 -  
'*                4 - 
'*                5 - Ͻ  
'*                6 - Ͻ 
'*                7 - 
'*               -1 - 
'*       :: ۿ
'*      ¥ :: 2002.01.22
'*
'****************************************************************************************

Public Function SetWebServerState(WebServerIndex As Integer, _
                                  StateNumber As Integer, _
                                  Optional WebServerName As String = "") As Integer
Attribute SetWebServerState.VB_Description = "     ¸  ,       ¸ Ѵ."
    
    Dim WebServer               As Object           '** IISWebServer ü
    Dim ADsPath                 As String           '** IISWebServer ü ADsPath
    Dim WebServerState          As Integer
    
    
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
    
On Error GoTo Error_Handler:

    
    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    WebServerName = Trim(WebServerName)
    
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC/" & CStr(WebServerIndex)
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC/" & CStr(WebServerIndex)
    End If
    
    
    '****************************************************************
    '*     ʱ ¸ ,  · Ѵ.
    '****************************************************************
    
    Set WebServer = GetObject(ADsPath)
    WebServerState = CInt(WebServer.ServerState)


    Select Case StateNumber
    
        Case 1  '**  **********************************
            If WebServerState = 3 Or WebServerState = 4 Then
                WebServer.Start
            ElseIf WebServerState = 5 Or WebServerState = 6 Then
                WebServer.Continue
            End If
            
        Case 2  '**  **********************************
            If WebServerState = 1 Or WebServerState = 2 Then
                WebServer.Stop
            End If
            
        Case 3  '** Ͻ  *****************************
            If WebServerState = 1 Or WebServerState = 2 Then
                WebServer.Pause
            End If
            
        Case Else  '***************************************
            If WebServerState = 3 Or WebServerState = 4 Then
                WebServer.Start
            End If
            
    End Select
    
    
    '**        ¸ ´.
    WebServer.GetInfo
    SetWebServerState = WebServer.ServerState
    Set WebServer = Nothing
    
    
    Exit Function
    
    
Error_Handler:


    '** Error ߻ -1  Return Ѵ.
    SetWebServerState = -1
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".SetWebServerState()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** IISWebServer ü 
    If Not WebServer Is Nothing Then
        Set WebServer = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function
    
    
End Function


'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function GetWebServerDefaultDoc(WebServerIndex As Integer,
'*                                                     Optional WebServerName As String = "") As String
'*       ::     ⺻   Ѵ.
'*       :: ۿ
'*      ¥ :: 2002.01.23
'*
'****************************************************************************************

Public Function GetWebServerDefaultDoc(WebServerIndex As Integer, _
                                       Optional WebServerName As String = "") As String
Attribute GetWebServerDefaultDoc.VB_Description = "    ⺻   Ѵ."

    Dim WebServerRoot           As Object           '** IIsWebVirtualDir ü
    Dim ADsPath                 As String           '** IIsWebVirtualDir ü ADsPath
    
    
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
    
On Error GoTo Error_Handler:
      
    
    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    WebServerName = Trim(WebServerName)
    
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC/" & CStr(WebServerIndex)
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC/" & CStr(WebServerIndex)
    End If
    
    
    '****************************************************************
    '* ⺻   ´.
    '****************************************************************
    
    Set WebServerRoot = GetObject(ADsPath & "/ROOT")
    GetWebServerDefaultDoc = WebServerRoot.DefaultDoc
    Set WebServerRoot = Nothing
    
    
    Exit Function
    
    
Error_Handler:


    '** Error ߻  ڿ Return Ѵ.
    GetWebServerDefaultDoc = ""
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".GetWebServerDefaultDoc()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** IIsWebVirtualDir ü 
    If Not WebServerRoot Is Nothing Then
        Set WebServerRoot = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function
    
    
End Function


'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function SetWebServerDefaultDoc(WebServerIndex As Integer,
'*                                                     DefaultDoc As String,
'*                                                     Optional WebServerName As String = "") As String
'*       ::     ⺻   Ѵ.
'*       :: ۿ
'*      ¥ :: 2002.01.23
'*
'****************************************************************************************

Public Function SetWebServerDefaultDoc(WebServerIndex As Integer, _
                                       DefaultDoc As String, _
                                       Optional WebServerName As String = "") As String
Attribute SetWebServerDefaultDoc.VB_Description = "    ⺻   Ѵ."
                                    
    Dim WebServerRoot           As Object           '** IIsWebVirtualDir ü
    Dim ADsPath                 As String           '** IIsWebVirtualDir ü ADsPath
        
        
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
    
On Error GoTo Error_Handler:
      
    
    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    WebServerName = Trim(WebServerName)
    
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC/" & CStr(WebServerIndex)
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC/" & CStr(WebServerIndex)
    End If
    
    
    '****************************************************************
    '* ⺻  Ѵ.
    '****************************************************************
    
    DefaultDoc = Replace(Trim(DefaultDoc), ", ", ",")
    If Right(DefaultDoc, 1) = "," Then DefaultDoc = Left(DefaultDoc, Len(DefaultDoc) - 1)
    
    Set WebServerRoot = GetObject(ADsPath & "/ROOT")
    WebServerRoot.DefaultDoc = DefaultDoc
    WebServerRoot.SetInfo
    
    
    '****************************************************************
    '* ŵ    ֽ  , ⺻   ´.
    '****************************************************************
    
    WebServerRoot.GetInfo
    SetWebServerDefaultDoc = WebServerRoot.DefaultDoc
    Set WebServerRoot = Nothing

    
    Exit Function
    
    
Error_Handler:


    '** Error ߻  ڿ Return Ѵ.
    SetWebServerDefaultDoc = ""
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".SetWebServerDefaultDoc()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** IIsWebVirtualDir ü 
    If Not WebServerRoot Is Nothing Then
        Set WebServerRoot = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function
    
    
End Function


'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function GetWebServerAccessPermit(WebServerIndex As Integer,
'*                                                       Optional WebServerName As String = "") As String
'*       ::     Access   Ѵ.
'*       :: ۿ
'*      ¥ :: 2002.01.23
'*
'****************************************************************************************

Public Function GetWebServerAccessPermit(WebServerIndex As Integer, _
                                         Optional WebServerName As String = "") As String
Attribute GetWebServerAccessPermit.VB_Description = "    Access   Ѵ."
                                
    Dim WebServerRoot           As Object           '** IIsWebVirtualDir ü
    Dim ADsPath                 As String           '** IIsWebVirtualDir ü ADsPath
    
    Dim AccessRead              As Integer
    Dim AccessWrite             As Integer
    Dim AccessScript            As Integer
    Dim AccessExecute           As Integer
    
    
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
    
On Error GoTo Error_Handler:
      
    
    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    WebServerName = Trim(WebServerName)
    
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC/" & CStr(WebServerIndex)
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC/" & CStr(WebServerIndex)
    End If
    
    
    '****************************************************************
    '* Access   ´.
    '****************************************************************
    
    Set WebServerRoot = GetObject(ADsPath & "/ROOT")
    
    AccessRead = 0
    AccessWrite = 0
    AccessScript = 0
    AccessExecute = 0
    
    If WebServerRoot.AccessRead = True Then AccessRead = 1
    If WebServerRoot.AccessWrite = True Then AccessWrite = 10
    If WebServerRoot.AccessScript = True Then AccessScript = 100
    If WebServerRoot.AccessExecute = True Then AccessExecute = 1000
        
    GetWebServerAccessPermit = Right("0000" & CStr(AccessRead + AccessWrite + AccessScript + AccessExecute), 4)
    Set WebServerRoot = Nothing

    
    Exit Function
    
    
Error_Handler:


    '** Error ߻  ڿ Return Ѵ.
    GetWebServerAccessPermit = ""
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".GetWebServerAccessPermit()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** IIsWebVirtualDir ü 
    If Not WebServerRoot Is Nothing Then
        Set WebServerRoot = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function
    
    
End Function


'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function SetWebServerAccessPermit(WebServerIndex As Integer,
'*                                                       Optional WebServerName As String = "") As String
'*       ::     Access   Ѵ.
'*       :: ۿ
'*      ¥ :: 2002.01.23
'*
'****************************************************************************************

Public Function SetWebServerAccessPermit(WebServerIndex As Integer, _
                                         Optional AccessRead As Boolean = True, _
                                         Optional AccessWrite As Boolean = False, _
                                         Optional AccessScript As Boolean = True, _
                                         Optional AccessExecute As Boolean = False, _
                                         Optional WebServerName As String = "") As String
Attribute SetWebServerAccessPermit.VB_Description = "    Access   Ѵ."
                                
    Dim WebServerRoot           As Object           '** IIsWebVirtualDir ü
    Dim ADsPath                 As String           '** IIsWebVirtualDir ü ADsPath
    
    Dim Temp_AccessRead         As Integer
    Dim Temp_AccessWrite        As Integer
    Dim Temp_AccessScript       As Integer
    Dim Temp_AccessExecute      As Integer
    
    
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
    
On Error GoTo Error_Handler:
    
    
    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    WebServerName = Trim(WebServerName)
    
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC/" & CStr(WebServerIndex)
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC/" & CStr(WebServerIndex)
    End If
    
    
    '****************************************************************
    '* Access   Ѵ.
    '****************************************************************
    
    Set WebServerRoot = GetObject(ADsPath & "/ROOT")
    With WebServerRoot
        .AccessRead = AccessRead
        .AccessWrite = AccessWrite
        .AccessScript = AccessScript
        .AccessExecute = AccessExecute
        .SetInfo
    
        Temp_AccessRead = 0
        Temp_AccessWrite = 0
        Temp_AccessScript = 0
        Temp_AccessExecute = 0
        
        .GetInfo
        If .AccessRead = True Then Temp_AccessRead = 1
        If .AccessWrite = True Then Temp_AccessWrite = 10
        If .AccessScript = True Then Temp_AccessScript = 100
        If .AccessExecute = True Then Temp_AccessExecute = 1000
    End With
    
    SetWebServerAccessPermit = Right("0000" & CStr(Temp_AccessRead + Temp_AccessWrite + Temp_AccessScript + Temp_AccessExecute), 4)
    Set WebServerRoot = Nothing
    
    
    Exit Function
    

Error_Handler:


    '** Error ߻  ڿ Return Ѵ.
    SetWebServerAccessPermit = ""
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".SetWebServerAccessPermit()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** IIsWebVirtualDir ü 
    If Not WebServerRoot Is Nothing Then
        Set WebServerRoot = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function


End Function


'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function GetLastWebServerIndex(Optional WebServerName As String = "") As Integer
'*       :: ϵ     Index ߿  ū  Ѵ.
'*       :: ۿ
'*      ¥ :: 2002.01.23
'*
'****************************************************************************************

Public Function GetLastWebServerIndex(Optional WebServerName As String = "") As Integer
Attribute GetLastWebServerIndex.VB_Description = "ϵ     Index ߿  ū  Ѵ."

    Dim WebService              As Object           '** IISWebService ü
    Dim WebServer               As Object           '** IISWebServer ü
    Dim ADsPath                 As String           '** IISWebService ü ADsPath
    
    Dim Index                   As Integer
    
    
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
    
On Error GoTo Error_Handler:


    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    WebServerName = Trim(WebServerName)
    
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC"
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC"
    End If
    
    
    '****************************************************************
    '*  IISWebServer ü Index  Ͽ  ū  ´.
    '****************************************************************
    
    Index = 0
    Set WebService = GetObject(ADsPath)
    
    For Each WebServer In WebService
    
        If IsNumeric(WebServer.Name) Then _
            If CInt(WebServer.Name) > Index Then Index = CInt(WebServer.Name)
        
    Next
    
    GetLastWebServerIndex = Index
    Set WebService = Nothing
    
    
    Exit Function
    

Error_Handler:


    '** Error ߻ -1  Return Ѵ.
    GetLastWebServerIndex = -1
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".GetLastWebServerIndex()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** IISWebService ü 
    If Not WebService Is Nothing Then
        Set WebService = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function
    
    
End Function


'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function GetWebServerBindings(WebServerIndex As Integer,
'*                                                   Optional WebServerName As String = "") As Variant
'*       ::     Binding  Ѵ.
'*       :: ۿ
'*      ¥ :: 2002.01.23
'*
'****************************************************************************************

Public Function GetWebServerBindings(WebServerIndex As Integer, _
                                     Optional WebServerName As String = "") As Variant
Attribute GetWebServerBindings.VB_Description = "    Binding  Ѵ."

    Dim WebServer               As Object           '** IISWebServer ü
    Dim ADsPath                 As String           '** IISWebServer ü ADsPath
    
    
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    

On Error GoTo Error_Handler:

    
    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    WebServerName = Trim(WebServerName)
    
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC/" & CStr(WebServerIndex)
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC/" & CStr(WebServerIndex)
    End If
    
    
    '****************************************************************
    '* Binding  ´.
    '****************************************************************
    
    Set WebServer = GetObject(ADsPath)
    GetWebServerBindings = WebServer.ServerBindings
    Set WebServer = Nothing
    
    
    Exit Function
    
    
Error_Handler:


    '** Error ߻  ڿ Return Ѵ.
    GetWebServerBindings = ""
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".GetWebServerBindings()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** IISWebServer ü 
    If Not WebServer Is Nothing Then
        Set WebServer = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function
    

End Function


'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function CreateWebServer(DisplayName As String,
'*                                              FullPath As String,
'*                                              Optional IPAddress As String = "",
'*                                              Optional Port As String = "80",
'*                                              Optional HostHeader As String = "",
'*                                              Optional WebServerName As String = "") As Integer
'*       :: ο    Ѵ.
'*       :: ۿ
'*      ¥ :: 2002.01.23
'*
'****************************************************************************************

Public Function CreateWebServer(DisplayName As String, _
                                FullPath As String, _
                                Optional IPAddress As String = "", _
                                Optional Port As String = "80", _
                                Optional HostHeader As String = "", _
                                Optional WebServerName As String = "") As Integer
Attribute CreateWebServer.VB_Description = "ο    Ѵ."

    Dim FSO                     As Scripting.FileSystemObject
    
    Dim WebService              As Object           '** IISWebService ü
    Dim WebServer               As Object           '** IISWebServer ü
    Dim WebServerRoot           As Object           '** IIsWebVirtualDir ü
    
    Dim ADsPath                 As String           '** IISWebServer ü ADsPath
    Dim BindingString           As String
        
    Dim LoopCount               As Integer
    Dim Index                   As Integer
    
    Dim Bindings                As Variant
    Dim NewBindings             As Variant
    
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
    
On Error GoTo Error_Handler:
    
    
    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    IPAddress = Trim(IPAddress)
    WebServerName = Trim(WebServerName)
    
    If IPAddress = "127.0.0.1" Or LCase(IPAddress) = "localhost" Then IPAddress = ""
    
        
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC"
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC"
    End If
        
    
    '****************************************************************
    '* IISWebService ü ´.
    '****************************************************************
    
    Set WebService = GetObject(ADsPath)
    
    
    '****************************************************************
    '* ü IIsWebServer , Binding  ߺǴ ˻Ѵ.
    '****************************************************************
    
    BindingString = IPAddress & ":" & Port & ":" & HostHeader
    
    On Error GoTo 0:

    For Each WebServer In WebService
    
        If WebServer.Class = "IIsWebServer" Then
        
            Bindings = WebServer.ServerBindings
            
            For LoopCount = 0 To UBound(Bindings)
            
                If LCase(BindingString) = LCase(Bindings(LoopCount)) Then
                
                    CreateWebServer = -1
                    Set WebService = Nothing
                    Err.Raise vbObjectError + 1, _
                              sObjectName & ".CreateWebServer()", _
                              "  ε  ٸ    ̹ ҴǾϴ."
                    
                    Exit Function
                    
                End If
                
            Next
            
        End If
        
    Next
    
    On Error GoTo Error_Handler:
    
    
    '****************************************************************
    '* ο    Ѵ.
    '****************************************************************
    
    Index = GetLastWebServerIndex(WebServerName) + 1
    Set WebServer = WebService.Create("IIsWebServer", Index)
        
    NewBindings = Array(0)
    NewBindings(0) = BindingString
    
    WebServer.ServerBindings = NewBindings
    WebServer.ServerComment = DisplayName
    WebServer.KeyType = "IIsWebServer"
    WebServer.SetInfo
  
  
    '****************************************************************
    '* ο  Root 丮 Ѵ.
    '****************************************************************
    
    Set WebServerRoot = WebServer.Create("IIsWebVirtualDir", "ROOT")
    
    Set FSO = New Scripting.FileSystemObject
    If Not FSO.FolderExists(FullPath) Then Call FSO.CreateFolder(FullPath)
    Set FSO = Nothing
    
    WebServerRoot.Path = FullPath
    WebServerRoot.AccessRead = True
    WebServerRoot.DefaultDoc = "Index.asp, Index.html, Index.htm"
    WebServerRoot.SetInfo
    

    '****************************************************************
    '* ο    Ѵ.
    '****************************************************************
    
    Set WebServer = GetObject(ADsPath & "/" & Index)
    WebServer.Start
    
    WebServerRoot.AppCreate True
    WebServerRoot.AppFriendlyName = DisplayName & "  α׷"
    WebServerRoot.SetInfo
    
    
    CreateWebServer = Index
    
    Set WebServerRoot = Nothing
    Set WebServer = Nothing
    Set WebService = Nothing
    
    
    Exit Function
    
    
Error_Handler:


    '** Error ߻ -1  Return Ѵ.
    CreateWebServer = -1
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".CreateWebServer()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** FileSystemObject ü 
    If Not FSO Is Nothing Then
        Set FSO = Nothing
    End If
    
    '** IIsWebVirtualDir ü 
    If Not WebServerRoot Is Nothing Then
        Set WebServerRoot = Nothing
    End If
    
    '** IISWebServer ü 
    If Not WebServer Is Nothing Then
        Set WebServer = Nothing
    End If
    
    '** IISWebService ü 
    If Not WebService Is Nothing Then
        Set WebService = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function
        
  
End Function


'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function DeleteWebServer(WebServerIndex As Integer,
'*                                              Optional WebServerName As String = "") As Boolean
'*       ::     Ѵ.
'*       :: ۿ
'*      ¥ :: 2002.06.25
'*
'****************************************************************************************

Public Function DeleteWebServer(WebServerIndex As Integer, _
                                Optional WebServerName As String = "") As Boolean
Attribute DeleteWebServer.VB_Description = "    Ѵ."

    Dim WebService              As Object           '** IISWebService ü
    Dim ADsPath                 As String           '** IISWebServer ü ADsPath
    
    
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
        
On Error GoTo Error_Handler:


    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    WebServerName = Trim(WebServerName)
    
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC"
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC"
    End If
    
    
    '****************************************************************
    '*     Ѵ.
    '****************************************************************
    
    Set WebService = GetObject(ADsPath)
    WebService.Delete "IISWebService", CStr(WebServerIndex)
    Set WebService = Nothing
    
    DeleteWebServer = True
        
    
    Exit Function
    
    
Error_Handler:

    
    '** Error ߻ False  Return Ѵ.
    DeleteWebServer = False
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".DeleteWebServer()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** IISWebService ü 
    If Not WebService Is Nothing Then
        Set WebService = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function
    
    
End Function


'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function CreateVirtualDir(VDirName As String,
'*                                               FullPath As String,
'*                                               WebServerIndex As Integer,
'*                                               Optional VDirParentsPos As String = "",
'*                                               Optional WebServerName As String = "",
'*                                               Optional Applevel As Integer = -1) As Boolean
'*       :: ο  ͸ Ѵ.
'*       :: ۿ
'*      ¥ :: 2002.06.26
'*
'****************************************************************************************

Public Function CreateVirtualDir(VDirName As String, _
                                 FullPath As String, _
                                 WebServerIndex As Integer, _
                                 Optional VDirParentsPos As String = "", _
                                 Optional WebServerName As String = "", _
                                 Optional Applevel As Integer = -1) As Boolean
Attribute CreateVirtualDir.VB_Description = "ο  ͸ Ѵ."
                                 
    Dim FSO                     As Scripting.FileSystemObject
    
    Dim WebVirtualDir           As Object           '** IIsWebVirtualDir ü
    Dim NewWebVirtualDir        As Object           '** IIsWebVirtualDir ü
    Dim oIADsComputer           As IADsComputer
        
    Dim ADsPath                 As String           '** IIsWebVirtualDir ü ADsPath
    
    Dim sOperatingSystem        As String
    Dim sOperatingSystemVer     As String
    
    
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
    
On Error GoTo Error_Handler:


    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    VDirParentsPos = Trim(VDirParentsPos)
    WebServerName = Trim(WebServerName)
    
    
    '** ROOT  ͸ ADsPath
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC/" & CStr(WebServerIndex) & "/ROOT"
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC/" & CStr(WebServerIndex) & "/ROOT"
    End If
    
    
    '**  ͸   ġ ADsPath
    If VDirParentsPos <> "" Then
        If Left(VDirParentsPos, 1) = "/" Then VDirParentsPos = Right(VDirParentsPos, Len(VDirParentsPos) - 1)
        If Right(VDirParentsPos, 1) = "/" Then VDirParentsPos = Left(VDirParentsPos, Len(VDirParentsPos) - 1)
        ADsPath = ADsPath & "/" & VDirParentsPos
    End If
    
    
    '****************************************************************
    '* IIsWebVirtualDir ü ´.
    '****************************************************************
    
    Set WebVirtualDir = GetObject(ADsPath)
    
    
    '****************************************************************
    '* ο  ͸ Ѵ.
    '****************************************************************
    
    Set NewWebVirtualDir = WebVirtualDir.Create("IIsWebVirtualDir", VDirName)
    
    Set FSO = New Scripting.FileSystemObject
    If Not FSO.FolderExists(FullPath) Then Call FSO.CreateFolder(FullPath)
    Set FSO = Nothing
    
    NewWebVirtualDir.Path = FullPath
    NewWebVirtualDir.SetInfo
    
    
    '****************************************************************
    '* Applevel ڿ    α׷ Ѵ.
    '*   -1 -  α׷  ʴ´.
    '*    0 - Inprocess  α׷ Ѵ.
    '*    1 - Outprocess  α׷ Ѵ.
    '*    2 - Windows 2000 ̻ ü Pooled  α׷
    '*         Ѵ. Windows NT  Inprocess  α׷
    '*        Ѵ.
    '****************************************************************
    
    If Applevel < -1 Or Applevel > 2 Then Applevel = -1
    
    If Applevel <> -1 Then
    
        '** OS        Computer ü 
        If WebServerName = "" Then
            ADsPath = "WinNT://" & GetLocalMachineName() & ",Computer"
        Else
            ADsPath = "WinNT://" & WebServerName & ",Computer"
        End If
        
        Set oIADsComputer = GetObject(ADsPath)
        sOperatingSystem = oIADsComputer.OperatingSystem
        sOperatingSystemVer = oIADsComputer.OperatingSystemVersion
        Set oIADsComputer = Nothing
        
        
        If LCase(sOperatingSystem) = "windows nt" Then
        
            If CSng(sOperatingSystemVer) >= 5 Then
            
                NewWebVirtualDir.AppCreate2 Applevel
            
            Else
            
                If Applevel = 0 Or Applevel = 2 Then
                    NewWebVirtualDir.AppCreate True
                Else
                    NewWebVirtualDir.AppCreate False
                End If
                
            End If
        
        End If
        
        NewWebVirtualDir.AppFriendlyName = VDirName & "  α׷"
        NewWebVirtualDir.SetInfo
    
    End If
    
    
    CreateVirtualDir = True
    
    Set NewWebVirtualDir = Nothing
    Set WebVirtualDir = Nothing
    
    
    Exit Function
    
    
Error_Handler:

    
    '** Error ߻ False  Return Ѵ.
    CreateVirtualDir = False
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".CreateVirtualDir()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** FileSystemObject ü 
    If Not FSO Is Nothing Then
        Set FSO = Nothing
    End If
    
    '** IADsComputer ü 
    If Not oIADsComputer Is Nothing Then
        Set oIADsComputer = Nothing
    End If
    
    '** IIsWebVirtualDir ü 
    If Not WebVirtualDir Is Nothing Then
        Set WebVirtualDir = Nothing
    End If
    
    '** IIsWebVirtualDir ü 
    If Not NewWebVirtualDir Is Nothing Then
        Set NewWebVirtualDir = Nothing
    End If
        
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function
    
    
End Function


'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function DeleteVirtualDir(VDirName As String,
'*                                               WebServerIndex As Integer,
'*                                               Optional VDirParentsPos As String = "",
'*                                               Optional WebServerName As String = "") As Boolean
'*       ::   ͸ Ѵ.
'*       :: ۿ
'*      ¥ :: 2002.06.26
'*
'****************************************************************************************

Public Function DeleteVirtualDir(VDirName As String, _
                                 WebServerIndex As Integer, _
                                 Optional VDirParentsPos As String = "", _
                                 Optional WebServerName As String = "") As Boolean
Attribute DeleteVirtualDir.VB_Description = "  ͸ Ѵ."

    Dim WebDir                  As Object           '** IIsWebVirtualDir ü Ǵ IIsWebDirectory ü
    
    Dim ADsPath                 As String


    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
        
On Error GoTo Error_Handler:

    
    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    VDirParentsPos = Trim(VDirParentsPos)
    WebServerName = Trim(WebServerName)
    
    
    '** ROOT  ͸ ADsPath
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC/" & CStr(WebServerIndex) & "/ROOT"
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC/" & CStr(WebServerIndex) & "/ROOT"
    End If
    
    
    '**   ͸ Container  ADsPath
    If VDirParentsPos <> "" Then
        If Left(VDirParentsPos, 1) = "/" Then VDirParentsPos = Right(VDirParentsPos, Len(VDirParentsPos) - 1)
        If Right(VDirParentsPos, 1) = "/" Then VDirParentsPos = Left(VDirParentsPos, Len(VDirParentsPos) - 1)
        ADsPath = ADsPath & "/" & VDirParentsPos
    End If
    
    
    '****************************************************************
    '*   ͸ Ѵ.
    '****************************************************************
    
    Set WebDir = GetObject(ADsPath)
    WebDir.Delete "IIsWebVirtualDir", CStr(VDirName)
    Set WebDir = Nothing
    
    DeleteVirtualDir = True
        
    
    Exit Function


Error_Handler:

    
    '** Error ߻ False  Return Ѵ.
    DeleteVirtualDir = False
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".DeleteVirtualDir()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** IIsWebVirtualDir ü Ǵ IIsWebDirectory ü 
    If Not WebDir Is Nothing Then
        Set WebDir = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function


End Function
                                 
                                 
'****************************************************************************************
'*
'*       :: Function
'*       :: Public Function GetWebServerList(Optional WebServerName As String = "") As ADODB.Recordset
'*       ::  Machine  ϴ     뷫  
'*               RecordSet ü  Ѵ.
'*       :: ۿ
'*      ¥ :: 2002.01.24
'*
'****************************************************************************************

Public Function GetWebServerList(Optional WebServerName As String = "") As ADODB.Recordset
Attribute GetWebServerList.VB_Description = " Machine  ϴ     뷫    RecordSet ü  Ѵ."
Attribute GetWebServerList.VB_UserMemId = 0

    Dim WebServerRec            As ADODB.Recordset
    
    Dim WebService              As Object           '** IISWebService ü
    Dim WebServer               As Object           '** IISWebServer ü
    Dim WebServerRoot           As Object           '** IIsWebVirtualDir ü
    
    Dim ADsPath                 As String           '** IISWebServer ü
    
    
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
    
On Error GoTo Error_Handler:
    
    
    '****************************************************************
    '*  RecordSet  ´.
    '****************************************************************
    
    Set WebServerRec = New ADODB.Recordset
    With WebServerRec
        .CursorLocation = adUseClient
        .Fields.Append "Index", adInteger
        .Fields.Append "Name", adVarChar, "256"
        .Fields.Append "ADsPath", adVarChar, "1024"
        .Fields.Append "State", adInteger
        .Fields.Append "DefaultDoc", adVarChar, "256"
        .Fields.Append "Path", adVarChar, "512"
        .Fields.Append "AccRead", adBoolean
        .Fields.Append "AccWrite", adBoolean
        .Fields.Append "AccScript", adBoolean
        .Fields.Append "AccExecute", adBoolean
        .Open
    End With
    
    
    '****************************************************************
    '* ADsPath  ´.
    '****************************************************************
    
    WebServerName = Trim(WebServerName)
    
    If WebServerName = "" Then
        ADsPath = "IIS://" & GetLocalMachineName() & "/W3SVC"
    Else
        ADsPath = "IIS://" & WebServerName & "/W3SVC"
    End If
    
    
    '****************************************************************
    '* IISWebService ü ´.
    '****************************************************************
    
    Set WebService = GetObject(ADsPath)
    
    
    '****************************************************************
    '*      о RecordSet ü Ѵ.
    '****************************************************************
    
    For Each WebServer In WebService
    
        If WebServer.Class = "IIsWebServer" Then
            
            With WebServerRec
                .AddNew
                .Fields("Index").Value = CInt(WebServer.Name)
                .Fields("Name").Value = WebServer.ServerComment
                .Fields("ADsPath").Value = WebServer.ADsPath
                .Fields("State").Value = CInt(WebServer.ServerState)
                Set WebServerRoot = GetObject(WebServer.ADsPath & "/ROOT")
                .Fields("DefaultDoc").Value = WebServerRoot.DefaultDoc
                .Fields("Path").Value = WebServerRoot.Path
                .Fields("AccRead").Value = WebServerRoot.AccessRead
                .Fields("AccWrite").Value = WebServerRoot.AccessWrite
                .Fields("AccScript").Value = WebServerRoot.AccessScript
                .Fields("AccExecute").Value = WebServerRoot.AccessExecute
                Set WebServerRoot = Nothing
                .Update
            End With
            
        End If
        
    Next
    
    
    WebServerRec.MoveFirst
    Set GetWebServerList = WebServerRec
    
    
    Exit Function
    
    
Error_Handler:


    '** Error ߻ Nothing  Return Ѵ.
    Set GetWebServerList = Nothing
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".GetWebServerList()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** IISWebService ü 
    If Not WebServerRec Is Nothing Then
        Set WebServerRec = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function
        

End Function


'****************************************************************************************
'*
'*       :: Function
'*       :: Private Function GetLocalMachineName() As String
'*       :: Local Machine  ̸ ´.
'*       :: ۿ
'*      ¥ :: 2002.01.22
'*
'****************************************************************************************

Private Function GetLocalMachineName() As String
Attribute GetLocalMachineName.VB_Description = "Ʈ ǰ ִ Machine  ̸ Ѵ."

    Dim ObjWinNTSystemInfo      As WinNTSystemInfo
    
    
    Dim lErr                    As Long             '** Error Number
    Dim sErr                    As String           '** Error Description
    Dim sMsg                    As String           '** Error Message
    
    
On Error GoTo Error_Handler:


    '****************************************************************
    '* Local Machine  ̸ ´.
    '****************************************************************
    
    Set ObjWinNTSystemInfo = New WinNTSystemInfo
    GetLocalMachineName = ObjWinNTSystemInfo.ComputerName
    Set ObjWinNTSystemInfo = Nothing
    
    Exit Function
    
    
Error_Handler:


    '** Error ߻  ڿ Return Ѵ.
    GetLocalMachineName = ""
    
    
    '** Error   Windows 2000 Event Log  Ѵ.
    lErr = Err.Number
    sErr = Err.Description
    sMsg = vbCrLf & vbCrLf & _
           "Error Location : " & sObjectName & ".GetLocalMachineName()" & vbCrLf & _
           "Error Number : " & lErr & "," & vbCrLf & _
           "Error Description : " & sErr
    App.LogEvent sMsg, vbLogEventTypeError
    
    
    '** WinNTSystemInfo ü 
    If Not ObjWinNTSystemInfo Is Nothing Then
        Set ObjWinNTSystemInfo = Nothing
    End If
    
    
    '** Error  ߻Ų.
    Err.Raise lErr, Err.Source, sErr
    
    
    Exit Function


End Function
